"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var expression_utils_1 = require("./../expression-utils");
var chai_1 = require("chai");
var _expressionUtils = new expression_utils_1.ExpressionUtils();
var ExpressionUsage = /** @class */ (function () {
    function ExpressionUsage() {
    }
    ExpressionUsage.lambda = function (expression) {
        var result = _expressionUtils.getColumnByLambdaExpression(expression);
        return result;
    };
    return ExpressionUsage;
}());
exports.ExpressionUsage = ExpressionUsage;
describe("Lambda Expression method", function () {
    it("should return id === 0", function () {
        var result = ExpressionUsage.lambda(function (x) { return x.id === 0; });
        chai_1.expect(result.columnLeft).to.equal("id");
        chai_1.expect(result.operator).to.equal("===");
        chai_1.expect(result.columnRight).to.equal("0");
    });
    it("should return id == 0", function () {
        // tslint:disable-next-line:triple-equals
        var result = ExpressionUsage.lambda(function (x) { return x.id == 0; });
        chai_1.expect(result.columnLeft).to.equal("id");
        chai_1.expect(result.operator).to.equal("==");
        chai_1.expect(result.columnRight).to.equal("0");
    });
    it("should return column with column", function () {
        var result = ExpressionUsage.lambda(function (x) { return x.id >= x.reference.id; });
        chai_1.expect(result.columnLeft).to.equal("id");
        chai_1.expect(result.operator).to.equal(">=");
        chai_1.expect(result.columnRight).to.equal("reference_id");
    });
    it("should value similar column", function () {
        var result1 = ExpressionUsage.lambda(function (x) { return x.name === "x.reference.id"; });
        chai_1.expect(result1.columnLeft).to.equal("name");
        chai_1.expect(result1.operator).to.equal("===");
        chai_1.expect(result1.columnRight).to.equal("\"x.reference.id\"");
        var result2 = ExpressionUsage.lambda(function (x) { return x.name === "x.reference.id"; });
        chai_1.expect(result2.columnLeft).to.equal("name");
        chai_1.expect(result2.operator).to.equal("===");
        chai_1.expect(result2.columnRight).to.equal("\"x.reference.id\"");
    });
    it("lambda column vs variable", function () {
        // let p1 = 0;
        // let contextObj = { p1: 0 };
        // const result = ExpressionUsage.lambda<ModelTest>((x) => x.id == p1);
        // expect(result.columnLeft).to.equal("id");
        // expect(result.operator).to.equal("==");
        // expect(result.columnRight).to.equal("0");
        // ExpressionUsage.test<ModelTest>((x) => x.id == contextObj.p1, contextObj);
        chai_1.expect(true).to.equal(true);
    });
});
